package gridexsolution;

import java.awt.Color;
import unit4.gridLib.Grid;

/**
 *  Document   : Sprite
 *  Created on : Feb 9, 2019, 5:59:30 PM
 *  Author     : Lavy
 */
public class Sprite
{
    private double row, col; // upper left corner
    private double dRow, dCol;
    private Color color;
    private boolean enabled;
    public Sprite(double row, double col, double dRow, double dCol, Color color)
    {
        this.row = row;
        this.col = col;
        this.color = color;
        this.dRow = dRow;
        this.dCol = dCol;
        this.enabled = true;
    }
    
    /**
     * moves the sprite to direction (dRow, dCol)
     * @param g 
     */
    public void move(Grid g)
    {
        if (enabled)
        {
            row += dRow;
            col += dCol;
            if ( col >= g.getColumnsCount() || col < 0)
            {
                dCol = -dCol;
            }
            if ( row >= g.getRowsCount() || row < 0)
            {
                dRow = -dRow;
            }
        }
    }
    
    public void draw(Grid g, int delay)
    {
        if ( enabled )
        {
            g.setCellColor((int)row, (int)col, color);
            g.setDelay(delay);
            g.setCellColor((int)row, (int)col, Color.white);
            g.setDelay(0);
        }
    }
    
    public boolean intersect(Sprite s)
    {
        return row == s.row && col == s.col;
    }

    public void setRow(double row)
    {
        this.row = row;
    }

    public void setCol(double col)
    {
        this.col = col;
    }

    public void setdRow(double dRow)
    {
        this.dRow = dRow;
    }

    public void setdCol(double dCol)
    {
        this.dCol = dCol;
    }

    public void setColor(Color color)
    {
        this.color = color;
    }

    public boolean isEnabled()
    {
        return enabled;
    }

    public void setEnabled(boolean enabled)
    {
        this.enabled = enabled;
    }
    
    
}
